&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-DOX-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-DOX-Frame 
/*------------------------------------------------------------------------

  File:            autodox/selectfiles.w

  Description:     select parameters for autodox/autodox.p
                   in GUI mode

  BORROWED:        From prolint/selectfiles.w (Jurjen Dijkstra)
  Author:          Murray Hermann

    -----------------------------------------------------------------

    Copyright (C) 2001,2002 Jurjen Dijkstra

    This file is part of Autodox.

    Prolint is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    Prolint is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with Prolint; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBulder.       */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
{autodox/dlc-version.i}

{autodox/sourcefiles.i}

DEFINE TEMP-TABLE tt_files NO-UNDO like tt_sourcefiles.

define input-output parameter initEd as character no-undo.
DEFINE INPUT PARAMETER Pdescription AS CHARACTER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER Pvalue AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER Pdescription2 AS CHARACTER NO-UNDO.
DEFINE INPUT-OUTPUT PARAMETER Pvalue2 AS CHARACTER NO-UNDO.
/* Parameters Definitions ---                                           */
&IF DEFINED(UIB_is_running)=0 &THEN
  DEFINE OUTPUT PARAMETER ModalResult AS INTEGER NO-UNDO INITIAL 0. 
  DEFINE OUTPUT PARAMETER pProfile    AS CHARACTER NO-UNDO INITIAL 0. 
  DEFINE OUTPUT PARAMETER TABLE FOR tt_sourcefiles.
  DEFINE OUTPUT PARAMETER pClearOutput AS LOGICAL NO-UNDO INITIAL TRUE.
&ELSE
  DEFINE VARIABLE ModalResult  AS INTEGER   NO-UNDO INITIAL 0.
  DEFINE VARIABLE pProfile     AS CHARACTER NO-UNDO INITIAL 0. 
  DEFINE VARIABLE pClearOutput AS LOGICAL   NO-UNDO INITIAL TRUE.
&ENDIF

DEFINE VARIABLE commentLevel    AS INTEGER   NO-UNDO.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Dialog-Box
&Scoped-define DB-AWARE no

&Scoped-define LAYOUT-VARIABLE CURRENT-WINDOW-layout

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME Dialog-DOX-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS EDITOR-1 ed_sourcefile FILL-IN-1 EDITOR-2 FILL-IN-2 Btn_OK Btn_Cancel Btn_Help 
&Scoped-Define DISPLAYED-OBJECTS EDITOR-1 ed_sourcefile FILL-IN-1 EDITOR-2 FILL-IN-2 fillInscanning 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD RelativeFileName Dialog-DOX-Frame 
FUNCTION RelativeFileName RETURNS CHARACTER
  ( pFileName AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* Define a variable to store the name of the active layout.            */
DEFINE VAR CURRENT-WINDOW-layout AS CHAR INITIAL "Master Layout":U NO-UNDO.

/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel 
     LABEL "Cancel":T 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 8 BY 1
     &ELSE SIZE 15 BY 1.14 &ENDIF
     BGCOLOR 8 .

DEFINE BUTTON Btn_Help 
     LABEL "&Help":T 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 8 BY 1
     &ELSE SIZE 15 BY 1.14 &ENDIF
     BGCOLOR 8 .

DEFINE BUTTON Btn_OK 
     LABEL "OK":T 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 8 BY 1
     &ELSE SIZE 15 BY 1.14 &ENDIF
     BGCOLOR 8 .

DEFINE VARIABLE EDITOR-1 AS CHARACTER 
     VIEW-AS EDITOR
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 30 BY 4
     &ELSE SIZE 53 BY 3.81 &ENDIF NO-UNDO.

DEFINE VARIABLE EDITOR-2 AS CHARACTER 
     VIEW-AS EDITOR
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 30 BY 4
     &ELSE SIZE 53 BY 3.81 &ENDIF NO-UNDO.

DEFINE VARIABLE ed_sourcefile AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP SCROLLBAR-HORIZONTAL SCROLLBAR-VERTICAL
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 30 BY 10
     &ELSE SIZE 84 BY 10.24 &ENDIF NO-UNDO.

DEFINE VARIABLE FILL-IN-1 AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 30 BY 1
     &ELSE SIZE 53 BY 1 &ENDIF NO-UNDO.

DEFINE VARIABLE FILL-IN-2 AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 30 BY 1
     &ELSE SIZE 53 BY 1 &ENDIF NO-UNDO.

DEFINE VARIABLE fillInscanning AS CHARACTER FORMAT "X(256)":U 
     LABEL "Scanning Area" 
     VIEW-AS FILL-IN 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 30 BY 1
     &ELSE SIZE 68.8 BY 1 &ENDIF NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME Dialog-DOX-Frame
     EDITOR-1
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 3 COL 40
          &ELSE AT ROW 1.95 COL 88 &ENDIF NO-LABEL
     ed_sourcefile
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 4 COL 2
          &ELSE AT ROW 2 COL 2 &ENDIF NO-LABEL
     FILL-IN-1
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 7 COL 40
          &ELSE AT ROW 5.76 COL 88 &ENDIF NO-LABEL
     EDITOR-2
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 9 COL 40
          &ELSE AT ROW 7.57 COL 88 &ENDIF NO-LABEL
     FILL-IN-2
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 14 COL 40
          &ELSE AT ROW 11.43 COL 88 &ENDIF NO-LABEL
     fillInscanning
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 16 COL 2
          &ELSE AT ROW 12.86 COL 2 &ENDIF NO-TAB-STOP 
     Btn_OK
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 16 COL 40
          &ELSE AT ROW 12.91 COL 96 &ENDIF
     Btn_Cancel
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 16 COL 50
          &ELSE AT ROW 12.91 COL 111 &ENDIF
     Btn_Help
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 16 COL 60
          &ELSE AT ROW 12.91 COL 126 &ENDIF
     "Specify one or more sourcefiles or directories to lint:":T VIEW-AS TEXT
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 65 BY 1
          &ELSE SIZE 65 BY .62 &ENDIF
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 1 COL 2
          &ELSE AT ROW 1.24 COL 2 &ENDIF
     "Set output directory and application name:" VIEW-AS TEXT
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 42 BY 1
          &ELSE SIZE 42 BY .62 &ENDIF
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 2 COL 30
          &ELSE AT ROW 1.1 COL 89 &ENDIF
     SPACE(12.79) SKIP(12.46)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Autodox- select files to document":T
         DEFAULT-BUTTON Btn_OK.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Dialog-Box
   Allow: Basic,Browse,DB-Fields,Query
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-DOX-Frame
                                                                        */
if session:batch-mode = FALSE then
do:
    
    ASSIGN 
           FRAME Dialog-DOX-Frame:SCROLLABLE       = FALSE
           FRAME Dialog-DOX-Frame:HIDDEN           = TRUE.
    
    ASSIGN 
           EDITOR-1:READ-ONLY IN FRAME Dialog-DOX-Frame        = TRUE.
    
    ASSIGN 
           EDITOR-2:READ-ONLY IN FRAME Dialog-DOX-Frame        = TRUE.
    
    ASSIGN 
           ed_sourcefile:RETURN-INSERTED IN FRAME Dialog-DOX-Frame  = TRUE.
    
    /* SETTINGS FOR FILL-IN FILL-IN-1 IN FRAME Dialog-DOX-Frame
       ALIGN-L                                                              */
    /* SETTINGS FOR FILL-IN FILL-IN-2 IN FRAME Dialog-DOX-Frame
       ALIGN-L                                                              */
    /* SETTINGS FOR FILL-IN fillInscanning IN FRAME Dialog-DOX-Frame
       NO-ENABLE ALIGN-L                                                    */
    
    /* _MULTI-LAYOUT-RUN-TIME-ADJUSTMENTS */
    
    /* LAYOUT-NAME: "Standard Character"
       LAYOUT-TYPE: CHARACTER
       EXPRESSION:  SESSION:DISPLAY-TYPE = 'TTY':U 
       COMMENT:     This layout is the standard layout specification for
                     a customized Character based terminal.  It is usually
                     selected to modify a window that has a GUI based
                     master layout.
                                                                            */
    IF SESSION:DISPLAY-TYPE = 'TTY':U  THEN 
      RUN CURRENT-WINDOW-layouts (INPUT 'Standard Character':U) NO-ERROR.
end.
/* END-OF-LAYOUT-DEFINITIONS */

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX Dialog-DOX-Frame
/* Query rebuild information for DIALOG-BOX Dialog-DOX-Frame
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX Dialog-DOX-Frame */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-DOX-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-DOX-Frame Dialog-DOX-Frame
ON WINDOW-CLOSE OF FRAME Dialog-DOX-Frame /* Autodox- select files to document */
DO:

   RUN Destructor.
   APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Cancel
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Cancel Dialog-DOX-Frame
ON CHOOSE OF Btn_Cancel IN FRAME Dialog-DOX-Frame /* Cancel */
DO:
  ModalResult = 0.
  if session:batch-mode = FALSE then 
      APPLY "go":U TO FRAME {&FRAME-NAME}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Help
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Help Dialog-DOX-Frame
ON CHOOSE OF Btn_Help IN FRAME Dialog-DOX-Frame /* Help */
OR HELP OF FRAME {&FRAME-NAME}
DO:
  DEF VAR ReturnValue AS INTEGER NO-UNDO.

  message "Add directory trees or file names (.p or .w)" view-as alert-box title "HELP".
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK Dialog-DOX-Frame
ON CHOOSE OF Btn_OK IN FRAME Dialog-DOX-Frame /* OK */
DO:
    /* copy contents of ed_sourcefiles to temp-table tt_sourcefiles */
    assign Pvalue  = INPUT FILL-IN-1
           Pvalue2 = INPUT FILL-IN-2
           ed_sourcefile
           initEd = ed_sourcefile.

  run coreCode (ed_sourcefile).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-DOX-Frame 


/* ***************************  Main Block  *************************** */

&IF {&dlc-version}>8 &THEN
ON DROP-FILE-NOTIFY OF FRAME {&FRAME-NAME} /* Prolint- select files to lint */
DO:
   DEFINE VARIABLE i AS INTEGER NO-UNDO.
   DEFINE VARIABLE numfiles AS INTEGER NO-UNDO. 

   numfiles = FRAME {&FRAME-NAME}:NUM-DROPPED-FILES.
   DO i=1 TO numfiles:
      RUN AddFile (FRAME {&FRAME-NAME}:GET-DROPPED-FILE(i)).
   END.
   FRAME {&FRAME-NAME}:END-FILE-DROP().  
END.
&ENDIF


/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF session:batch-mode = FALSE and VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  assign ed_sourcefile = initEd
         EDITOR-1 = Pdescription
         FILL-IN-1 = Pvalue
         EDITOR-2 = Pdescription2
         FILL-IN-2 = Pvalue2
         fillInscanning = "".

  if session:batch-mode = FALSE then 
      RUN enable_UI.

  /* enable drag/drop if the version allows it */
  &IF {&dlc-version}>8 &THEN
      IF SessionWindowSystem="GUI":U and session:batch-mode = FALSE then
          FRAME {&FRAME-NAME}:DROP-TARGET = YES.
  &ENDIF

  if session:batch-mode = FALSE then
  do:
  
    APPLY "entry":U TO ed_sourcefile.

    WAIT-FOR GO OF FRAME {&FRAME-NAME}.
  end.
  else
    run coreCode (initEd).

  RUN Destructor.
END.

if session:batch-mode = FALSE then 
    RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE AddFile Dialog-DOX-Frame 
PROCEDURE AddFile :
/*------------------------------------------------------------------------------
  Purpose:     add file to tt_sourcefiles if it doesn't already exist
  Parameters:  newfile = filename
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER newfile AS CHAR NO-UNDO.

  FILE-INFO:FILE-NAME = newfile.
  IF FILE-INFO:FULL-PATHNAME = ? THEN RETURN.

  IF FILE-INFO:FILE-TYPE MATCHES "*F*":U THEN DO:
     IF NOT ((newfile MATCHES "*~~.p":U) OR (newfile MATCHES "*~~.w":U)) THEN
        RETURN.
  END.

  newfile = RelativeFileName(newfile).
     
  DO WITH FRAME {&FRAME-NAME} :
     ed_sourcefile:MOVE-TO-TOP().
     ed_sourcefile:INSERT-STRING(newfile + "~n":U).
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE AddOneSourceFile Dialog-DOX-Frame 
PROCEDURE AddOneSourceFile :
/* purpose : add name of sourcefile to tt_files.
      That way we can assure the names are unique,
      we can count the files and show a percentage done,
      and we won't have to run LintOneSourceFile from within
      the recursive directory-scan (high stack usage) */
   DEFINE INPUT PARAMETER p-SourceFile AS CHARACTER NO-UNDO.
   def var p-SourceFileRel as char no-undo.

   p-SourceFileRel = RelativeFilename(p-SourceFile).
   FIND tt_files WHERE tt_files.sourcefile = p-SourceFileRel NO-ERROR.
   IF NOT AVAILABLE tt_files THEN DO:
      CREATE tt_files.
      ASSIGN tt_files.sourcefile = p-SourcefileRel
             /*tt_files.shortFileName = p-sourcefile*/.
   END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE AddOneSourceItem Dialog-DOX-Frame 
PROCEDURE AddOneSourceItem :
/* purpose: SourceItem can be a filename or a directoryname.
               if it's a directory then lint all files in it */
   DEFINE INPUT PARAMETER p-SourceItem AS CHARACTER NO-UNDO.

   DEFINE VARIABLE basename AS CHARACTER NO-UNDO.
   DEFINE VARIABLE fullpath AS CHARACTER NO-UNDO.
   DEFINE VARIABLE attribs  AS CHARACTER NO-UNDO.

   process events.
   FILE-INFO:FILE-NAME = p-SourceItem.

    /*Skip directories starting with \previous*/
   if replace(p-SourceItem, "/", "~\") matches "*~\previous*":U 
       and FILE-INFO:FILE-TYPE MATCHES "*D*":U then return.

   if session:batch-mode = FALSE then
       disp p-SourceItem @ fillInscanning WITH FRAME {&FRAME-NAME}.

   IF FILE-INFO:FULL-PATHNAME = ? THEN
   do:
       output to autodox.err append.
       put unformatted "File not found: p-SourceItem" skip.
       output close.
   end.
   ELSE
      IF FILE-INFO:FILE-TYPE MATCHES "*F*":U THEN
      do:
          /*Load the content of any text files*/
        if p-SourceItem matches "*~~.txt" then
        do:
            INPUT FROM VALUE( SEARCH(p-SourceItem) ).
            file-loop:
            REPEAT ON ERROR UNDO, LEAVE:

                PROCESS EVENTS.

                    /*Input the file name and don't allow txt files in txt files*/
                IMPORT UNFORMATTED basename.
                IF basename = "" or basename matches "*~~.txt" THEN
                    NEXT file-loop.
  
                IF basename = "/*" THEN
                    ASSIGN commentlevel = commentlevel + 1.

                IF commentlevel = 0 AND basename <> "*/" THEN 
                DO:
                    FILE-INFO:FILE-NAME = basename.
                    RUN AddOneSourceFile(FILE-INFO:FULL-PATHNAME).
                end.

                IF basename = "*/" THEN
                    ASSIGN commentlevel = commentlevel - 1.
            end. /*file-loop*/
            input close.
        end.
        else RUN AddOneSourceFile(FILE-INFO:FULL-PATHNAME).
      end.
      ELSE
         IF FILE-INFO:FILE-TYPE MATCHES "*D*":U THEN DO:
            /* scan directory contents. recursive! */
            INPUT FROM OS-DIR (FILE-INFO:FULL-PATHNAME).
            REPEAT:
                IMPORT basename fullpath attribs.
                IF attribs MATCHES "*D*":U AND NOT(basename=".":U OR basename="..":U) THEN
                   RUN AddOneSourceItem(fullpath).
                IF attribs MATCHES "*F*":U THEN
                   IF (basename MATCHES "*~~.w":U) OR (basename MATCHES "*~~.p":U) THEN
                      RUN AddOneSourceFile(fullpath).
            END.
            INPUT CLOSE.
         END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE Destructor Dialog-DOX-Frame 
PROCEDURE Destructor :
/*------------------------------------------------------------------------------
  Purpose:     on close of the window, free all resources
------------------------------------------------------------------------------*/
  IF ModalResult=0 THEN 
  &IF {&dlc-version}>8 &THEN
    empty temp-table tt_sourcefiles.
  &ELSE
    for each tt_sourcefiles: delete tt_sourcefiles. end.
  &ENDIF

  if session:batch-mode = FALSE then hide FRAME {&FRAME-NAME} no-pause.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-DOX-Frame  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Dialog-DOX-Frame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-DOX-Frame  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY EDITOR-1 ed_sourcefile FILL-IN-1 EDITOR-2 FILL-IN-2 fillInscanning 
      WITH FRAME Dialog-DOX-Frame.
  ENABLE EDITOR-1 ed_sourcefile FILL-IN-1 EDITOR-2 FILL-IN-2 Btn_OK Btn_Cancel 
         Btn_Help 
      WITH FRAME Dialog-DOX-Frame.
  VIEW FRAME Dialog-DOX-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-DOX-Frame}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK  _PROCEDURE CURRENT-WINDOW-layouts _LAYOUT-CASES
PROCEDURE CURRENT-WINDOW-layouts:
  DEFINE INPUT PARAMETER layout AS CHARACTER                     NO-UNDO.
  DEFINE VARIABLE lbl-hndl AS WIDGET-HANDLE                      NO-UNDO.
  DEFINE VARIABLE widg-pos AS DECIMAL                            NO-UNDO.

  /* Copy the name of the active layout into a variable accessible to   */
  /* the rest of this file.                                             */
  CURRENT-WINDOW-layout = layout.

  CASE layout:
    WHEN "Master Layout" THEN DO:
      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME Dialog-DOX-Frame:HIDDEN                     = yes &ENDIF
         FRAME Dialog-DOX-Frame:HEIGHT                     = 13.19
               + FRAME Dialog-DOX-Frame:BORDER-TOP + FRAME Dialog-DOX-Frame:BORDER-BOTTOM
         FRAME Dialog-DOX-Frame:WIDTH                      = 142.8
               + FRAME Dialog-DOX-Frame:BORDER-LEFT + FRAME Dialog-DOX-Frame:BORDER-RIGHT.

      ASSIGN
         Btn_Cancel:HIDDEN IN FRAME Dialog-DOX-Frame       = yes
         Btn_Cancel:HEIGHT IN FRAME Dialog-DOX-Frame       = 1.14
         Btn_Cancel:ROW IN FRAME Dialog-DOX-Frame          = 12.91
         Btn_Cancel:HIDDEN IN FRAME Dialog-DOX-Frame       = no.

      ASSIGN
         Btn_Help:HIDDEN IN FRAME Dialog-DOX-Frame         = yes
         Btn_Help:HEIGHT IN FRAME Dialog-DOX-Frame         = 1.14
         Btn_Help:ROW IN FRAME Dialog-DOX-Frame            = 12.91
         Btn_Help:HIDDEN IN FRAME Dialog-DOX-Frame         = no.

      ASSIGN
         Btn_OK:HIDDEN IN FRAME Dialog-DOX-Frame           = yes
         Btn_OK:HEIGHT IN FRAME Dialog-DOX-Frame           = 1.14
         Btn_OK:ROW IN FRAME Dialog-DOX-Frame              = 12.91
         Btn_OK:HIDDEN IN FRAME Dialog-DOX-Frame           = no.

      ASSIGN
         EDITOR-1:HIDDEN IN FRAME Dialog-DOX-Frame         = yes
         EDITOR-1:HEIGHT IN FRAME Dialog-DOX-Frame         = 3.81
         EDITOR-1:ROW IN FRAME Dialog-DOX-Frame            = 1.95
         EDITOR-1:HIDDEN IN FRAME Dialog-DOX-Frame         = no.

      ASSIGN
         EDITOR-2:HIDDEN IN FRAME Dialog-DOX-Frame         = yes
         EDITOR-2:HEIGHT IN FRAME Dialog-DOX-Frame         = 3.81
         EDITOR-2:ROW IN FRAME Dialog-DOX-Frame            = 7.57
         EDITOR-2:HIDDEN IN FRAME Dialog-DOX-Frame         = no.

      ASSIGN
         ed_sourcefile:HIDDEN IN FRAME Dialog-DOX-Frame    = yes
         ed_sourcefile:HEIGHT IN FRAME Dialog-DOX-Frame    = 10.24
         ed_sourcefile:ROW IN FRAME Dialog-DOX-Frame       = 2
         ed_sourcefile:WIDTH IN FRAME Dialog-DOX-Frame     = 84
         ed_sourcefile:HIDDEN IN FRAME Dialog-DOX-Frame    = no.

      ASSIGN
         FILL-IN-1:HIDDEN IN FRAME Dialog-DOX-Frame        = yes
         FILL-IN-1:ROW IN FRAME Dialog-DOX-Frame           = 5.76
         FILL-IN-1:HIDDEN IN FRAME Dialog-DOX-Frame        = no.

      ASSIGN
         FILL-IN-2:HIDDEN IN FRAME Dialog-DOX-Frame        = yes
         FILL-IN-2:ROW IN FRAME Dialog-DOX-Frame           = 11.43
         FILL-IN-2:HIDDEN IN FRAME Dialog-DOX-Frame        = no.

      ASSIGN
         fillInscanning:HIDDEN IN FRAME Dialog-DOX-Frame  = yes
         widg-pos = fillInscanning:COL IN FRAME Dialog-DOX-Frame 
         fillInscanning:COL IN FRAME Dialog-DOX-Frame     = 17.2
         lbl-hndl = fillInscanning:SIDE-LABEL-HANDLE IN FRAME Dialog-DOX-Frame 
         lbl-hndl:COL = lbl-hndl:COL + fillInscanning:COL IN FRAME Dialog-DOX-Frame  - widg-pos
         widg-pos = fillInscanning:ROW IN FRAME Dialog-DOX-Frame 
         fillInscanning:ROW IN FRAME Dialog-DOX-Frame     = 12.86
         lbl-hndl = fillInscanning:SIDE-LABEL-HANDLE IN FRAME Dialog-DOX-Frame 
         lbl-hndl:ROW = lbl-hndl:ROW + fillInscanning:ROW IN FRAME Dialog-DOX-Frame  - widg-pos
         fillInscanning:WIDTH IN FRAME Dialog-DOX-Frame   = 68.8
         fillInscanning:HIDDEN IN FRAME Dialog-DOX-Frame  = no.

      ASSIGN

         FRAME Dialog-DOX-Frame:VIRTUAL-HEIGHT             = 13.19
                    WHEN FRAME Dialog-DOX-Frame:SCROLLABLE

         FRAME Dialog-DOX-Frame:VIRTUAL-WIDTH              = 142.80
                    WHEN FRAME Dialog-DOX-Frame:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME Dialog-DOX-Frame:HIDDEN                     = no &ENDIF.

    END.  /* Master Layout Layout Case */

    WHEN "Standard Character":U THEN DO:
 /*     ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME Dialog-DOX-Frame:HIDDEN                     = yes &ENDIF
         FRAME Dialog-DOX-Frame:HEIGHT                     = 15
               + FRAME Dialog-DOX-Frame:BORDER-TOP + FRAME Dialog-DOX-Frame:BORDER-BOTTOM
         FRAME Dialog-DOX-Frame:WIDTH                      = 73
               + FRAME Dialog-DOX-Frame:BORDER-LEFT + FRAME Dialog-DOX-Frame:BORDER-RIGHT NO-ERROR.

      ASSIGN
         Btn_Cancel:HIDDEN IN FRAME Dialog-DOX-Frame       = yes
         Btn_Cancel:HEIGHT IN FRAME Dialog-DOX-Frame       = 1
         Btn_Cancel:ROW IN FRAME Dialog-DOX-Frame          = 13
         Btn_Cancel:HIDDEN IN FRAME Dialog-DOX-Frame       = no NO-ERROR.

      ASSIGN
         Btn_Help:HIDDEN IN FRAME Dialog-DOX-Frame         = yes
         Btn_Help:HEIGHT IN FRAME Dialog-DOX-Frame         = 1
         Btn_Help:ROW IN FRAME Dialog-DOX-Frame            = 13
         Btn_Help:HIDDEN IN FRAME Dialog-DOX-Frame         = no NO-ERROR.

      ASSIGN
         Btn_OK:HIDDEN IN FRAME Dialog-DOX-Frame           = yes
         Btn_OK:HEIGHT IN FRAME Dialog-DOX-Frame           = 1
         Btn_OK:ROW IN FRAME Dialog-DOX-Frame              = 13
         Btn_OK:HIDDEN IN FRAME Dialog-DOX-Frame           = no NO-ERROR.

      ASSIGN
         EDITOR-1:HIDDEN IN FRAME Dialog-DOX-Frame         = yes
         EDITOR-1:HEIGHT IN FRAME Dialog-DOX-Frame         = 4
         EDITOR-1:ROW IN FRAME Dialog-DOX-Frame            = 2
         EDITOR-1:HIDDEN IN FRAME Dialog-DOX-Frame         = no NO-ERROR.

      ASSIGN
         EDITOR-2:HIDDEN IN FRAME Dialog-DOX-Frame         = yes
         EDITOR-2:HEIGHT IN FRAME Dialog-DOX-Frame         = 4
         EDITOR-2:ROW IN FRAME Dialog-DOX-Frame            = 8
         EDITOR-2:HIDDEN IN FRAME Dialog-DOX-Frame         = no NO-ERROR.

      ASSIGN
         ed_sourcefile:HIDDEN IN FRAME Dialog-DOX-Frame    = yes
         ed_sourcefile:HEIGHT IN FRAME Dialog-DOX-Frame    = 10
         ed_sourcefile:ROW IN FRAME Dialog-DOX-Frame       = 4
         ed_sourcefile:WIDTH IN FRAME Dialog-DOX-Frame     = 71
         ed_sourcefile:HIDDEN IN FRAME Dialog-DOX-Frame    = no NO-ERROR.

      ASSIGN
         FILL-IN-1:HIDDEN IN FRAME Dialog-DOX-Frame        = yes
         FILL-IN-1:ROW IN FRAME Dialog-DOX-Frame           = 6
         FILL-IN-1:HIDDEN IN FRAME Dialog-DOX-Frame        = no NO-ERROR.

      ASSIGN
         FILL-IN-2:HIDDEN IN FRAME Dialog-DOX-Frame        = yes
         FILL-IN-2:ROW IN FRAME Dialog-DOX-Frame           = 11
         FILL-IN-2:HIDDEN IN FRAME Dialog-DOX-Frame        = no NO-ERROR.

      ASSIGN
         fillInscanning:HIDDEN IN FRAME Dialog-DOX-Frame  = yes
         widg-pos = fillInscanning:COL IN FRAME Dialog-DOX-Frame 
         fillInscanning:COL IN FRAME Dialog-DOX-Frame     = 2
         lbl-hndl = fillInscanning:SIDE-LABEL-HANDLE IN FRAME Dialog-DOX-Frame 
         lbl-hndl:COL = lbl-hndl:COL + fillInscanning:COL IN FRAME Dialog-DOX-Frame  - widg-pos
         widg-pos = fillInscanning:ROW IN FRAME Dialog-DOX-Frame 
         fillInscanning:ROW IN FRAME Dialog-DOX-Frame     = 13
         lbl-hndl = fillInscanning:SIDE-LABEL-HANDLE IN FRAME Dialog-DOX-Frame 
         lbl-hndl:ROW = lbl-hndl:ROW + fillInscanning:ROW IN FRAME Dialog-DOX-Frame  - widg-pos
         fillInscanning:WIDTH IN FRAME Dialog-DOX-Frame   = 30
         fillInscanning:HIDDEN IN FRAME Dialog-DOX-Frame  = no NO-ERROR.
                                                                 
      ASSIGN

         FRAME Dialog-DOX-Frame:VIRTUAL-HEIGHT             = 25.00
                    WHEN FRAME Dialog-DOX-Frame:SCROLLABLE

         FRAME Dialog-DOX-Frame:VIRTUAL-WIDTH              = 143.00
                    WHEN FRAME Dialog-DOX-Frame:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME Dialog-DOX-Frame:HIDDEN                     = no &ENDIF NO-ERROR.
                                                                */
    END.  /* Standard Character Layout Case */

  END CASE.
END PROCEDURE.  /* CURRENT-WINDOW-layouts */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION RelativeFileName Dialog-DOX-Frame 
FUNCTION RelativeFileName RETURNS CHARACTER
  ( pFileName AS CHARACTER ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
DEFINE VARIABLE fullpath  AS CHAR NO-UNDO.
   DEFINE VARIABLE shortpath AS CHAR NO-UNDO.
   DEFINE VARIABLE i         AS INTEGER NO-UNDO.

   /* first replace all backslashes by forwardslashes */
   pFileName = REPLACE(pFileName, '~\':U, '/':U).  
     
   FILE-INFO:FILE-NAME = pFileName.
   fullpath = FILE-INFO:FULL-PATHNAME.
                
   shortpath = ENTRY(NUM-ENTRIES(pFileName, '/':U), pFileName, '/':U).
   DO i=NUM-ENTRIES(pFileName, '/':U) TO 2 BY -1 :
      FILE-INFO:FILE-NAME = shortpath.
      /*IF REPLACE(FILE-INFO:FULL-PATHNAME, '~\':U, '/':U) = REPLACE(fullpath, '~\':U, '/':U) THEN*/
      IF search(shortpath) <> ? THEN
         RETURN shortpath.                          
      shortpath = ENTRY(i - 1, pFileName, '/':U) + '/':U + shortpath.   
   END.
   
   RETURN pFileName.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE coreCode 
PROCEDURE coreCode :
/*------------------------------------------------------------------------------
  Purpose:     main code logic
------------------------------------------------------------------------------*/
    def input param sourceFiles as char no-undo.
    
    DEFINE VARIABLE i AS INTEGER NO-UNDO.
    DEFINE VARIABLE chLine AS CHARACTER NO-UNDO.
    

    ModalResult = 1.



    DO i=1 TO NUM-ENTRIES(sourceFiles,"~n":U) :  
       chLine = TRIM(ENTRY(i,sourceFiles,"~n":U)).
       IF chLine <> "" THEN
          IF NOT CAN-FIND(tt_sourcefiles WHERE tt_sourcefiles.sourcefile=chLine) THEN DO:
             CREATE tt_sourcefiles.
             ASSIGN tt_sourcefiles.sourcefile = chLine.
          END.
    END.

   for each tt_sourcefiles no-lock:
          run AddOneSourceItem(tt_sourcefiles.sourcefile).
          if session:batch-mode = FALSE then 
              disp "" @ fillInscanning WITH FRAME {&FRAME-NAME}.
    end.

    &IF {&dlc-version}>8 &THEN
      empty temp-table tt_sourcefiles.
    &ELSE
      for each tt_sourcefiles: delete tt_sourcefiles. end.
    &ENDIF

    for each tt_files no-lock:
        create tt_sourcefiles.
        ASSIGN tt_sourcefiles.sourcefile = tt_files.sourcefile.
    end.

    &IF {&dlc-version}>8 &THEN
      empty temp-table tt_files.
    &ELSE
      for each tt_files: delete tt_files. end.
    &ENDIF

    if session:batch-mode = FALSE then
    do:
        hide fillInscanning in FRAME {&FRAME-NAME} no-pause.

        APPLY "go":U TO FRAME {&FRAME-NAME}.
    end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
