run createTableHTML("client").

procedure createTableHTML :
    def input parameter tableName as char no-undo.

    def var found as logical no-undo.
    def var i as int no-undo.
    def var j as int no-undo.
    def var qh             as handle       no-undo.    /*query handle*/
    def var bhFile         as handle       no-undo.
    def var bhField        as handle       no-undo.
    def var queryString    as char         no-undo.    /*query string*/
    def var queryTest      as logical      no-undo.  
    def var queryObject     as char         no-undo.
    def var queryFieldObj  as char no-undo.
    def var db              as char         no-undo.
    def var bfh as handle no-undo.      /*Buffer field handle*/



  /*Now try and find the DB associated with the tableName or it could be a 
    temp-table.  Assume its a DB table first and then go looking for the 
    temp-table later
  */

  found = FALSE.
  FIND-TABLE-BLOCK:
  repeat i = 1 to NUM-DBS:
      assign queryObject = LDBNAME(i) + "._file"
             queryFieldObj = LDBNAME(i) + "._field".

      queryString = "for each " + queryObject + " where " +
                     queryObject + "._file-name = '" + tableName + "', "+
                    "each " + queryFieldObj + " of " + queryObject + " no-lock".

      create query qh.                           /*Create new query*/
      create buffer bhfile for table queryObject.    /*Map dynamic buffer to table*/
      create buffer bhfield for table queryFieldObj.    /*Map dynamic buffer to table*/
      qh:set-buffers(bhfile, bhfield).
      queryTest = qh:query-prepare(queryString).
      qh:query-open().
      qh:get-first().
      DO-BLK:
      do while not qh:query-off-end:
        assign found = TRUE
        db = LDBNAME(i)
        bfh = qh:get-buffer-handle(2).  /*The _field*/
        repeat j = 1 to bfh:num-fields:
            if lookup(bfh:buffer-field(j):name, "_format,_data-type,_field-name,_extent") = 0 then next.
            disp bfh:buffer-field(j):name format "x(50)"
                 bfh:buffer-field(j):buffer-value() format "x(15)".
        end.
        /*delete object bfh.*/
        qh:get-next().
      end. /*do*/
      qh:query-close().
      /*delete object bhFile.
      delete object bhField.                     */
      delete object qh.
      if found = TRUE then leave FIND-TABLE-BLOCK.
  end.
    /*If not found then it must be a temp-table*/
  if found = FALSE then
  do:
      message tableName view-as alert-box title "Not found".
  end.
end.
